---
title: Game over
slug: Games/Tutorials/2D_Breakout_game_pure_JavaScript/Game_over
tags:
  - Beginner
  - Canvas
  - Games
  - Graphics
  - JavaScript
  - Tutorial
  - game over
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Paddle_and_keyboard_controls", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Build_the_brick_field")}}</p>

<div class="summary">
<p>This is the <strong>5th step</strong> out of 10 of the <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch">Gamedev Canvas tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Canvas-workshop/blob/gh-pages/lesson05.html">Gamedev-Canvas-workshop/lesson5.html</a>.</p>
</div>

<p><span class="seoSummary">It's fun to watch the ball bouncing off the walls and be able to move the paddle around, but other than that the game does nothing and doesn't have any progression or end goal. It would be good from the gameplay point of view to be able to lose. The logic behind losing in breakout is simple. If you miss the ball with the paddle and let it reach the bottom edge of the screen, then it's game over.</span></p>

<h2 id="Implementing_game_over">Implementing game over</h2>

<p>Let's try to implement game over in our game. Here's the piece of code from the third lesson where we made the ball bounce off the walls:</p>

<pre class="brush: js notranslate">if(x + dx &gt; canvas.width-ballRadius || x + dx &lt; ballRadius) {
    dx = -dx;
}

if(y + dy &gt; canvas.height-ballRadius || y + dy &lt; ballRadius) {
    dy = -dy;
}</pre>

<p>Instead of allowing the ball to bounce off all four walls, let's only allow three now — left, top and right. Hitting the bottom wall will end the game. We'll edit the second if block so it's an if else block that will trigger our "game over" state upon the ball colliding with the bottom edge of the canvas. For now we'll keep it simple, showing an alert message and restarting the game by reloading the page.</p>

<p>First, replace where you initially called <code>setInterval()</code></p>

<pre class="notranslate">setInterval(draw, 10);
</pre>

<p>with:</p>

<pre class="notranslate">var interval = setInterval(draw, 10);
</pre>

<p>Then replace the second if statement with the following:</p>

<pre class="brush: js notranslate">if(y + dy &lt; ballRadius) {
    dy = -dy;
} else if(y + dy &gt; canvas.height-ballRadius) {
    alert("GAME OVER");
    document.location.reload();
    clearInterval(interval); // Needed for Chrome to end game
}
</pre>

<h2 id="Letting_the_paddle_hit_the_ball">Letting the paddle hit the ball</h2>

<p>The last thing to do in this lesson is to create some kind of collision detection between the ball and the paddle, so it can bounce off it and get back into the play area. The easiest thing to do is to check whether the center of the ball is between the left and right edges of the paddle. Update the last bit of code you modified again, to the following:</p>

<pre class="brush: js notranslate">if(y + dy &lt; ballRadius) {
    dy = -dy;
} else if(y + dy &gt; canvas.height-ballRadius) {
    if(x &gt; paddleX &amp;&amp; x &lt; paddleX + paddleWidth) {
        dy = -dy;
    }
    else {
        alert("GAME OVER");
        document.location.reload();
        clearInterval(interval);
    }
}</pre>

<p>If the ball hits the bottom edge of the Canvas we need to check whether it hits the paddle . if yes, then it bounces off just like you'd expect; if not then the game is over as before.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>Here's the working code for you to compare yours against:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/raymondjplante/L61c9y50/","","395")}}</p>

<div class="note">
<p><strong>Exercise</strong>: make the ball move faster when it hits the paddle.</p>
</div>

<h2 id="Next_steps">Next steps</h2>

<p>We're doing quite well so far and our game is starting to feel a lot more worth playing now you can lose! But it is still missing something. Let's move on  to the sixth chapter — <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch/Build_the_brick_field">Build the brick field</a> — and create some bricks for the ball to destroy.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Paddle_and_keyboard_controls", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Build_the_brick_field")}}</p>
